/* Copyright 2012 by Moti Ben-Ari under the GNU GPL; see readme.txt */

typedef separate {
  chan sync = [1] of { bool }
};

inline wait_separate(formal1, formal2) {
  atomic {
    formal1.sync ? [_] && formal2.sync ? [_] ->
    formal1.sync ? _;
    formal2.sync ? _
  }
}

inline release_separate(formal1, formal2) {
  atomic {
    formal1.sync ! true;
    formal2.sync ! true
  }
}

inline start_separate(formal) {
  formal.sync ! true;
}

inline end_separate(formal) {
  formal.sync ? _;
}

byte numEating = 0;

separate forks[5];

proctype Phil(byte n; separate left; separate right ) {
  do 
  :: wait_separate(left, right);
     numEating++;
     assert (numEating <= 2);
     numEating--;
     release_separate(left, right);
  od
}

proctype Fork(separate sep) {
  do
  ::  start_separate(sep);
      end_separate(sep)
  od
}

init {
  atomic {
    run Fork(forks[0]);
    run Fork(forks[1]);
    run Fork(forks[2]);
    run Fork(forks[3]);
    run Fork(forks[4]);
    run Phil(0, forks[0], forks[1]);
    run Phil(1, forks[1], forks[2]);
    run Phil(2, forks[2], forks[3]);
    run Phil(3, forks[3], forks[4]);
    run Phil(4, forks[4], forks[0])
  }
}
